# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.io_k8s_apimachinery_pkg_api_resource_quantity import IoK8sApimachineryPkgApiResourceQuantity  # noqa: F401,E501
from swagger_server import util


class IoK8sApiCoreV1ResourceRequirements(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, limits: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]=None, requests: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]=None):  # noqa: E501
        """IoK8sApiCoreV1ResourceRequirements - a model defined in Swagger

        :param limits: The limits of this IoK8sApiCoreV1ResourceRequirements.  # noqa: E501
        :type limits: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        :param requests: The requests of this IoK8sApiCoreV1ResourceRequirements.  # noqa: E501
        :type requests: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        """
        self.swagger_types = {
            'limits': Dict[str, IoK8sApimachineryPkgApiResourceQuantity],
            'requests': Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        }

        self.attribute_map = {
            'limits': 'limits',
            'requests': 'requests'
        }
        self._limits = limits
        self._requests = requests

    @classmethod
    def from_dict(cls, dikt) -> 'IoK8sApiCoreV1ResourceRequirements':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The io.k8s.api.core.v1.ResourceRequirements of this IoK8sApiCoreV1ResourceRequirements.  # noqa: E501
        :rtype: IoK8sApiCoreV1ResourceRequirements
        """
        return util.deserialize_model(dikt, cls)

    @property
    def limits(self) -> Dict[str, IoK8sApimachineryPkgApiResourceQuantity]:
        """Gets the limits of this IoK8sApiCoreV1ResourceRequirements.

        Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/  # noqa: E501

        :return: The limits of this IoK8sApiCoreV1ResourceRequirements.
        :rtype: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        """
        return self._limits

    @limits.setter
    def limits(self, limits: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]):
        """Sets the limits of this IoK8sApiCoreV1ResourceRequirements.

        Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/  # noqa: E501

        :param limits: The limits of this IoK8sApiCoreV1ResourceRequirements.
        :type limits: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        """

        self._limits = limits

    @property
    def requests(self) -> Dict[str, IoK8sApimachineryPkgApiResourceQuantity]:
        """Gets the requests of this IoK8sApiCoreV1ResourceRequirements.

        Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/  # noqa: E501

        :return: The requests of this IoK8sApiCoreV1ResourceRequirements.
        :rtype: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        """
        return self._requests

    @requests.setter
    def requests(self, requests: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]):
        """Sets the requests of this IoK8sApiCoreV1ResourceRequirements.

        Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: https://kubernetes.io/docs/concepts/configuration/manage-compute-resources-container/  # noqa: E501

        :param requests: The requests of this IoK8sApiCoreV1ResourceRequirements.
        :type requests: Dict[str, IoK8sApimachineryPkgApiResourceQuantity]
        """

        self._requests = requests
